import openmedialib
import properties

class operand:
	def __init__( self, uri, input = None, callback = None ):
		self.uri = uri
		self.properties = []
		self.input = input
		self.callback = callback

	def __str__( self ):
		if len( self.properties ):
			return self.uri + " " + str( self.properties )
		else:
			return self.uri

	def __int__( self ):
		return int( self.uri )

	def assign( self, node ):
		for i in self.properties:
			split = i.split( "=" )
			if split[ 0 ][ 0:2 ] == "@@" or split[ 1 ][ 0:2 ] == "@@":
				properties.update_prop( node, split[ 0 ], str( split[ 1 ] ) )
			else:
				property = properties.find_prop( node, split[ 0 ] )
				if split[ 1 ][ 0 ] == "@":
					temp = properties.find_prop( node, split[ 1 ] )
					value = properties.value_prop( temp )
				else:
					value = split[ 1 ]
				if property is not None:
					properties.assign_prop( property, split[ 0 ], value )

class input_operand( openmedialib.input_delegate ):
	def __init__( self, uri, operand ):
		openmedialib.input_delegate.__init__( self )
		self.operand = operand
		self.uri = uri
		for prop in operand.properties:
			split = prop.split( "=" )
			properties.update_prop( self, split[ 0 ], split[ 1 ] )

	def __str__( self ):
		return str( self.uri )

	def __int__( self ):
		return int( self.uri )

	def reset( self ): 
		pass

	def get_uri( self ): 
		return self.uri

	def get_mime_type( self ):
		return unicode( "" )

	def get_frames( self ):
		return 0

	def is_seekable( self ):
		return False

	def get_video_streams( self ):
		return 0

	def get_audio_streams( self ):
		return 0

	def set_video_stream( self, index ):
		return False

	def set_audio_stream( self, index ):
		return False

	def seek( self, position, relative = False ):
		pass

	def get_position( self ):
		return 0

	def fetch( self ):
		return None

	def push( self, frame ):
		return False

	def refresh_cache( self, frame ):
		pass

	def reuse( self ):
		return False

